/**
 * Created by chenzhiyi on 16/3/29.
 */

(function() {

    var mainFn = window.mainFn = {
        init: function () {
            mainFn.reWindow();
            if (window.FileReader) {
                mainFn.uploadImg();
            } else {
                $('.img-wrap').hide();
            }
            mainFn.submitData();
        },
        reWindow: function () {
            // 调整页面布局
            // var pageHeight = $(window).height();
            // $('.main').css('min-height', pageHeight);
            // 聚焦输入框时去掉边框高亮
            $('.text-wrap .text-input').focus(function () {
                $('.text-wrap .text-input').css('border', '1px solid #ccc');
            });
            var lan = mainFn.getUrlParam('lan');
            if (lan === 'zh' || lan === 'cn') {
                $('.text-wrap .text-input').attr('placeholder', '请输入您的宝贵意见');
                $('.email-wrap .email-input').attr('placeholder', '请留下您的邮箱或者手机号码');
                $('.submit-button').html('提交');
            }
        },
        uploadImg: function () {
            // 图片上传
            $('.img-wrap .upload-button').on('change', function () {
                if (!this.files.length) {
                    return;
                }
                var files = this.files;
                var self = this;
                var MaxSize = 1024 * 1024;
                $('.img-wrap .upload-img-name').css('color', '#777');
                if (files[0] && files[0].size > MaxSize) {
                    $('.img-wrap .upload-img-name').text('Image size over 1M').css('color', '#e94543');
                    $('.img-wrap .upload-button').attr('data-base64', '');
                    return;
                }
                if (!(files[0] && files[0].type.match('image.*'))) {
                    $('.img-wrap .upload-img-name').text('Image format not supported').css('color', '#e94543');
                    $('.img-wrap .upload-button').attr('data-base64', '');
                    return;
                }
                var reader = new FileReader();
                reader.readAsDataURL(files[0]);
                reader.onload = function(e) {
                    self.dataset.base64 = this.result;
                };
                var filename = files[0].name || (this.value || '').match(/([^\\\/]+?)$/)[1];
                $('.img-wrap .upload-img-name').text(filename);
            });
        },
        getUrlParam: function (param) {
            var stringRule = new RegExp("(\\?|#|&)" + param + "=([^&#]*)(&|#|$)");
            var getValue = location.href.match(stringRule);
            return getValue ? getValue[2] : "";
        },
        tipsBox: function (str) {
            $('#tipsBox p').text(str);
            $('#tipsBox').show();
            setTimeout(function () {
                $('#tipsBox').hide();
            }, 1800);
        },
        submitData: function () {
            // 数据提交
            var lan = mainFn.getUrlParam('lan');
            var tipsTxt = {
                emptyContent: 'The feedback content is empty',
                success: 'Thanks for you feedback',
                wrong: 'There seems to be something wrong'
            };
            if (lan === 'zh' || lan === 'cn') {
                tipsTxt = {
                    emptyContent: '请填写反馈内容',
                    success: '感谢您的反馈',
                    wrong: '好像出了状况，请稍后重试'
                };
            }

            $('.submit-button').on('click', function () {
                var feedbackContent = $('.text-wrap .text-input').val();
                var userEmail = $('.email-wrap .email-input').val();
                var imgBase64 = $('.img-wrap .upload-button').attr('data-base64');
                var uid = mainFn.getUrlParam('uid');
                if (!feedbackContent) {
                    $('.text-wrap  .text-input').css('border', '1px solid #E94543');
                    mainFn.tipsBox(tipsTxt.emptyContent);
                    return;
                }
                var urlParams = {
                    uid: uid,
                    appid: '209053',               // 目前写死，并不是产品线id
                    content: feedbackContent,
                    referer: 'moboGameTexasPoker',
                    tel: userEmail,
                    screenshot: imgBase64
                    // m:'Client',
                    // a:'postMsg',
                    // extend_feedback_channel:this.extend_feedback_channel,
                    // product_type:this.product_type,
                    // bduss: this.bduss,
                    // wise新增
                    // bw:this.baidu_id,
                    // kw:this.extend_query,
                    // tn:this.extend_tn,
                    // wr:this.wiseReferrer,
                    // extend_doc_id : _self.extend_doc_id,
                    // ajax:1
                };

                $.post('http://ufosdk.baidu.com/?m=Client&a=postMsg', urlParams, function(data) {
                    data = JSON.parse(data);
                    // console.log(data);
                    if (data.errno) {
                        // 提交失败
                        mainFn.tipsBox(tipsTxt.wrong);
                    } else {
                        // 提交成功
                        mainFn.tipsBox(tipsTxt.success);
                        // 清空原来填写内容
                        $('.text-wrap .text-input').val('');
                        $('.email-wrap .email-input').val('');
                        $('.img-wrap .upload-button').attr('data-base64', '');
                        $('.img-wrap .upload-img-name').html('');
                    }
                });
            });
        }
    };

    mainFn.init();

})();